Library odbc33; //(c) romix, 2006
uses Windows, SysUtils, IniFiles;

var lpCriticalSection: _RTL_CRITICAL_SECTION;


var g_ms: Integer;
var g_cnt: Integer; // ,     1,2,4,8,16,32,64...1024    .
var g_LastErrorTime: DWORD; //    (   ).
//   g_LastErrorTime   2 ,   g_cnt    1 .

var g_LogSQL: String;

const c_start = 1;


//////////////////////////////////////////////////////////
procedure GetIniFile();
var dir, fname: String;
var ini: TIniFile;
begin
  try
    dir:=ExtractFilePath(ParamStr(0));
    fname:=dir+'odbc33.ini';
    if FileExists(fname)=false then begin
      MessageBox(0, pchar(' : '+fname), '', 0);
      exit;
    end;
    ini:=TIniFile.Create(fname);
    g_ms:=ini.ReadInteger('Options', 'Delay', 1024);
    g_logSQL:=ini.ReadString('Options', 'LogSQL', '');
    ini.Free;
  except
  end;
end;

(*
//////////////////////////////////////////////////////////
procedure LogQuery(s: String);
var f: TextFile;
begin
   {$I+}
   AssignFile(f, g_LogSQL);

   try
   if FileExists(g_LogSQL) then begin
     Append(f);
   end else begin
     Rewrite(f);
   end;

   Write(f, TimeToStr(now),': ');
   Writeln(f, s);

   finally
     {$I-}
       CloseFile(f);
     {$I+}
   end;
end;
*)


//////////////////////////////////////////////////////////
//  ,   sleep
function  SQLExecDirectA_orig(p1, p2, p3: pchar):DWORD; stdcall; external 'odbc32.dll' name 'SQLExecDirectA';
  function SQLExecDirectA(p1, p2, p3: pchar):DWORD; export; stdcall;
  var w: DWORD;
  var diff: DWORD;
  begin
    Result:=SQLExecDirectA_orig(p1,p2,p3);

//    if g_LogSQL<>'' then LogQuery(p2);

    w:=Result and $FFFF; //  
    if w=2 then begin //SQL_STILL_EXECUTING -    
        //       
        if pos('{call _1sp__1SJOURN_TLockX}', p2)>0 then begin
          if g_ms>0 then begin
             EnterCriticalSection(lpCriticalSection);

             // ,        ( 2 . )
             diff:=GetTickCount()-g_LastErrorTime;
             if (diff)>2000 then g_cnt:=c_start;
             // 
             if g_cnt<g_ms then g_cnt:=g_cnt*2;
             //MessageBox(0, pchar(IntToStr(g_cnt)), pchar(IntToStr(diff)), 0);
             g_LastErrorTime:=GetTickCount();

             LeaveCriticalSection(lpCriticalSection);
             sleep(g_cnt); //""  ,        SQL

          end;
        end;
    end;
  end;
  exports SQLExecDirectA;



//  -  ,   jmp   .
//    ,     - ,  
// , .


//////////////////////////////////////////////////////////
procedure SQLExecDirect_orig; external 'odbc32.dll' name 'SQLExecDirect';
  procedure SQLExecDirect; export; stdcall;
  begin
   asm
     jmp SQLExecDirect_orig;
   end;
  end;
  exports SQLExecDirect;

//////////////////////////////////////////////////////////
procedure SQLExecDirectW_orig; external 'odbc32.dll' name 'SQLExecDirectW';
  procedure SQLExecDirectW; export; stdcall;
  begin
   asm
     jmp SQLExecDirectW_orig;
   end;
  end;
  exports SQLExecDirectW;

//////////////////////////////////////////////////////////
procedure CloseODBCPerfData_orig; external 'odbc32.dll' name 'CloseODBCPerfData';
  procedure CloseODBCPerfData; export; stdcall;
  begin 
   asm 
     jmp CloseODBCPerfData_orig; 
   end; 
  end;
  exports CloseODBCPerfData;
//////////////////////////////////////////////////////////
procedure CollectODBCPerfData_orig; external 'odbc32.dll' name 'CollectODBCPerfData';
  procedure CollectODBCPerfData; export; stdcall;
  begin 
   asm 
     jmp CollectODBCPerfData_orig; 
   end;
  end;
  exports CollectODBCPerfData;
//////////////////////////////////////////////////////////
procedure CursorLibLockDbc_orig; external 'odbc32.dll' name 'CursorLibLockDbc';
  procedure CursorLibLockDbc; export; stdcall;
  begin 
   asm 
     jmp CursorLibLockDbc_orig; 
   end; 
  end;
  exports CursorLibLockDbc;
//////////////////////////////////////////////////////////
procedure CursorLibLockDesc_orig; external 'odbc32.dll' name 'CursorLibLockDesc';
  procedure CursorLibLockDesc; export; stdcall;
  begin 
   asm 
     jmp CursorLibLockDesc_orig; 
   end; 
  end;
  exports CursorLibLockDesc;
//////////////////////////////////////////////////////////
procedure CursorLibLockStmt_orig; external 'odbc32.dll' name 'CursorLibLockStmt';
  procedure CursorLibLockStmt; export; stdcall;
  begin 
   asm 
     jmp CursorLibLockStmt_orig; 
   end; 
  end;
  exports CursorLibLockStmt;
//////////////////////////////////////////////////////////
procedure CursorLibTransact_orig; external 'odbc32.dll' name 'CursorLibTransact';
  procedure CursorLibTransact; export; stdcall;
  begin 
   asm 
     jmp CursorLibTransact_orig; 
   end; 
  end;
  exports CursorLibTransact;
//////////////////////////////////////////////////////////
procedure GetODBCSharedData_orig; external 'odbc32.dll' name 'GetODBCSharedData';
  procedure GetODBCSharedData; export; stdcall;
  begin 
   asm 
     jmp GetODBCSharedData_orig; 
   end; 
  end;
  exports GetODBCSharedData;
//////////////////////////////////////////////////////////
procedure LockHandle_orig; external 'odbc32.dll' name 'LockHandle';
  procedure LockHandle; export; stdcall;
  begin 
   asm 
     jmp LockHandle_orig; 
   end; 
  end;
  exports LockHandle;
//////////////////////////////////////////////////////////
procedure MpHeapAlloc_orig; external 'odbc32.dll' name 'MpHeapAlloc';
  procedure MpHeapAlloc; export; stdcall;
  begin 
   asm 
     jmp MpHeapAlloc_orig; 
   end; 
  end;
  exports MpHeapAlloc;
//////////////////////////////////////////////////////////
procedure MpHeapCompact_orig; external 'odbc32.dll' name 'MpHeapCompact';
  procedure MpHeapCompact; export; stdcall;
  begin 
   asm 
     jmp MpHeapCompact_orig; 
   end; 
  end;
  exports MpHeapCompact;
//////////////////////////////////////////////////////////
procedure MpHeapCreate_orig; external 'odbc32.dll' name 'MpHeapCreate';
  procedure MpHeapCreate; export; stdcall;
  begin 
   asm 
     jmp MpHeapCreate_orig; 
   end; 
  end;
  exports MpHeapCreate;
//////////////////////////////////////////////////////////
procedure MpHeapDestroy_orig; external 'odbc32.dll' name 'MpHeapDestroy';
  procedure MpHeapDestroy; export; stdcall;
  begin 
   asm 
     jmp MpHeapDestroy_orig; 
   end; 
  end;
  exports MpHeapDestroy;
//////////////////////////////////////////////////////////
procedure MpHeapFree_orig; external 'odbc32.dll' name 'MpHeapFree';
  procedure MpHeapFree; export; stdcall;
  begin 
   asm 
     jmp MpHeapFree_orig; 
   end; 
  end;
  exports MpHeapFree;
//////////////////////////////////////////////////////////
procedure MpHeapReAlloc_orig; external 'odbc32.dll' name 'MpHeapReAlloc';
  procedure MpHeapReAlloc; export; stdcall;
  begin 
   asm 
     jmp MpHeapReAlloc_orig; 
   end; 
  end;
  exports MpHeapReAlloc;
//////////////////////////////////////////////////////////
procedure MpHeapSize_orig; external 'odbc32.dll' name 'MpHeapSize';
  procedure MpHeapSize; export; stdcall;
  begin 
   asm 
     jmp MpHeapSize_orig; 
   end; 
  end;
  exports MpHeapSize;
//////////////////////////////////////////////////////////
procedure MpHeapValidate_orig; external 'odbc32.dll' name 'MpHeapValidate';
  procedure MpHeapValidate; export; stdcall;
  begin 
   asm 
     jmp MpHeapValidate_orig; 
   end; 
  end;
  exports MpHeapValidate;
//////////////////////////////////////////////////////////
procedure ODBCGetTryWaitValue_orig; external 'odbc32.dll' name 'ODBCGetTryWaitValue';
  procedure ODBCGetTryWaitValue; export; stdcall;
  begin 
   asm 
     jmp ODBCGetTryWaitValue_orig; 
   end; 
  end;
  exports ODBCGetTryWaitValue;
//////////////////////////////////////////////////////////
procedure ODBCInternalConnectW_orig; external 'odbc32.dll' name 'ODBCInternalConnectW';
  procedure ODBCInternalConnectW; export; stdcall;
  begin 
   asm 
     jmp ODBCInternalConnectW_orig; 
   end; 
  end;
  exports ODBCInternalConnectW;
//////////////////////////////////////////////////////////
procedure ODBCQualifyFileDSNW_orig; external 'odbc32.dll' name 'ODBCQualifyFileDSNW';
  procedure ODBCQualifyFileDSNW; export; stdcall;
  begin 
   asm 
     jmp ODBCQualifyFileDSNW_orig; 
   end; 
  end;
  exports ODBCQualifyFileDSNW;
//////////////////////////////////////////////////////////
procedure ODBCSetTryWaitValue_orig; external 'odbc32.dll' name 'ODBCSetTryWaitValue';
  procedure ODBCSetTryWaitValue; export; stdcall;
  begin 
   asm 
     jmp ODBCSetTryWaitValue_orig; 
   end; 
  end;
  exports ODBCSetTryWaitValue;
//////////////////////////////////////////////////////////
procedure OpenODBCPerfData_orig; external 'odbc32.dll' name 'OpenODBCPerfData';
  procedure OpenODBCPerfData; export; stdcall;
  begin 
   asm 
     jmp OpenODBCPerfData_orig; 
   end; 
  end;
  exports OpenODBCPerfData;
//////////////////////////////////////////////////////////
procedure PostComponentError_orig; external 'odbc32.dll' name 'PostComponentError';
  procedure PostComponentError; export; stdcall;
  begin 
   asm 
     jmp PostComponentError_orig; 
   end; 
  end;
  exports PostComponentError;
//////////////////////////////////////////////////////////
procedure PostODBCComponentError_orig; external 'odbc32.dll' name 'PostODBCComponentError';
  procedure PostODBCComponentError; export; stdcall;
  begin 
   asm 
     jmp PostODBCComponentError_orig; 
   end; 
  end;
  exports PostODBCComponentError;
//////////////////////////////////////////////////////////
procedure PostODBCError_orig; external 'odbc32.dll' name 'PostODBCError';
  procedure PostODBCError; export; stdcall;
  begin 
   asm 
     jmp PostODBCError_orig; 
   end; 
  end;
  exports PostODBCError;
//////////////////////////////////////////////////////////
procedure SQLAllocConnect_orig; external 'odbc32.dll' name 'SQLAllocConnect';
  procedure SQLAllocConnect; export; stdcall;
  begin 
   asm 
     jmp SQLAllocConnect_orig; 
   end; 
  end;
  exports SQLAllocConnect;
//////////////////////////////////////////////////////////
procedure SQLAllocEnv_orig; external 'odbc32.dll' name 'SQLAllocEnv';
  procedure SQLAllocEnv; export; stdcall;
  begin 
   asm 
     jmp SQLAllocEnv_orig; 
   end; 
  end;
  exports SQLAllocEnv;
//////////////////////////////////////////////////////////
procedure SQLAllocHandle_orig; external 'odbc32.dll' name 'SQLAllocHandle';
  procedure SQLAllocHandle; export; stdcall;
  begin 
   asm 
     jmp SQLAllocHandle_orig; 
   end; 
  end;
  exports SQLAllocHandle;
//////////////////////////////////////////////////////////
procedure SQLAllocHandleStd_orig; external 'odbc32.dll' name 'SQLAllocHandleStd';
  procedure SQLAllocHandleStd; export; stdcall;
  begin 
   asm 
     jmp SQLAllocHandleStd_orig; 
   end; 
  end;
  exports SQLAllocHandleStd;
//////////////////////////////////////////////////////////
procedure SQLAllocStmt_orig; external 'odbc32.dll' name 'SQLAllocStmt';
  procedure SQLAllocStmt; export; stdcall;
  begin 
   asm 
     jmp SQLAllocStmt_orig; 
   end; 
  end;
  exports SQLAllocStmt;
//////////////////////////////////////////////////////////
procedure SQLBindCol_orig; external 'odbc32.dll' name 'SQLBindCol';
  procedure SQLBindCol; export; stdcall;
  begin 
   asm 
     jmp SQLBindCol_orig; 
   end; 
  end;
  exports SQLBindCol;
//////////////////////////////////////////////////////////
procedure SQLBindParam_orig; external 'odbc32.dll' name 'SQLBindParam';
  procedure SQLBindParam; export; stdcall;
  begin 
   asm 
     jmp SQLBindParam_orig; 
   end; 
  end;
  exports SQLBindParam;
//////////////////////////////////////////////////////////
procedure SQLBindParameter_orig; external 'odbc32.dll' name 'SQLBindParameter';
  procedure SQLBindParameter; export; stdcall;
  begin 
   asm 
     jmp SQLBindParameter_orig; 
   end; 
  end;
  exports SQLBindParameter;
//////////////////////////////////////////////////////////
procedure SQLBrowseConnect_orig; external 'odbc32.dll' name 'SQLBrowseConnect';
  procedure SQLBrowseConnect; export; stdcall;
  begin 
   asm 
     jmp SQLBrowseConnect_orig; 
   end; 
  end;
  exports SQLBrowseConnect;
//////////////////////////////////////////////////////////
procedure SQLBrowseConnectA_orig; external 'odbc32.dll' name 'SQLBrowseConnectA';
  procedure SQLBrowseConnectA; export; stdcall;
  begin 
   asm 
     jmp SQLBrowseConnectA_orig; 
   end; 
  end;
  exports SQLBrowseConnectA;
//////////////////////////////////////////////////////////
procedure SQLBrowseConnectW_orig; external 'odbc32.dll' name 'SQLBrowseConnectW';
  procedure SQLBrowseConnectW; export; stdcall;
  begin 
   asm 
     jmp SQLBrowseConnectW_orig; 
   end; 
  end;
  exports SQLBrowseConnectW;
//////////////////////////////////////////////////////////
procedure SQLBulkOperations_orig; external 'odbc32.dll' name 'SQLBulkOperations';
  procedure SQLBulkOperations; export; stdcall;
  begin 
   asm 
     jmp SQLBulkOperations_orig; 
   end; 
  end;
  exports SQLBulkOperations;
//////////////////////////////////////////////////////////
procedure SQLCancel_orig; external 'odbc32.dll' name 'SQLCancel';
  procedure SQLCancel; export; stdcall;
  begin 
   asm 
     jmp SQLCancel_orig; 
   end; 
  end;
  exports SQLCancel;
//////////////////////////////////////////////////////////
procedure SQLCloseCursor_orig; external 'odbc32.dll' name 'SQLCloseCursor';
  procedure SQLCloseCursor; export; stdcall;
  begin 
   asm 
     jmp SQLCloseCursor_orig; 
   end; 
  end;
  exports SQLCloseCursor;
//////////////////////////////////////////////////////////
procedure SQLColAttribute_orig; external 'odbc32.dll' name 'SQLColAttribute';
  procedure SQLColAttribute; export; stdcall;
  begin 
   asm 
     jmp SQLColAttribute_orig; 
   end; 
  end;
  exports SQLColAttribute;
//////////////////////////////////////////////////////////
procedure SQLColAttributeA_orig; external 'odbc32.dll' name 'SQLColAttributeA';
  procedure SQLColAttributeA; export; stdcall;
  begin 
   asm 
     jmp SQLColAttributeA_orig; 
   end; 
  end;
  exports SQLColAttributeA;
//////////////////////////////////////////////////////////
procedure SQLColAttributeW_orig; external 'odbc32.dll' name 'SQLColAttributeW';
  procedure SQLColAttributeW; export; stdcall;
  begin 
   asm 
     jmp SQLColAttributeW_orig; 
   end; 
  end;
  exports SQLColAttributeW;
//////////////////////////////////////////////////////////
procedure SQLColAttributes_orig; external 'odbc32.dll' name 'SQLColAttributes';
  procedure SQLColAttributes; export; stdcall;
  begin 
   asm 
     jmp SQLColAttributes_orig; 
   end; 
  end;
  exports SQLColAttributes;
//////////////////////////////////////////////////////////
procedure SQLColAttributesA_orig; external 'odbc32.dll' name 'SQLColAttributesA';
  procedure SQLColAttributesA; export; stdcall;
  begin 
   asm 
     jmp SQLColAttributesA_orig; 
   end; 
  end;
  exports SQLColAttributesA;
//////////////////////////////////////////////////////////
procedure SQLColAttributesW_orig; external 'odbc32.dll' name 'SQLColAttributesW';
  procedure SQLColAttributesW; export; stdcall;
  begin 
   asm 
     jmp SQLColAttributesW_orig; 
   end; 
  end;
  exports SQLColAttributesW;
//////////////////////////////////////////////////////////
procedure SQLColumnPrivileges_orig; external 'odbc32.dll' name 'SQLColumnPrivileges';
  procedure SQLColumnPrivileges; export; stdcall;
  begin 
   asm 
     jmp SQLColumnPrivileges_orig; 
   end; 
  end;
  exports SQLColumnPrivileges;
//////////////////////////////////////////////////////////
procedure SQLColumnPrivilegesA_orig; external 'odbc32.dll' name 'SQLColumnPrivilegesA';
  procedure SQLColumnPrivilegesA; export; stdcall;
  begin 
   asm 
     jmp SQLColumnPrivilegesA_orig; 
   end; 
  end;
  exports SQLColumnPrivilegesA;
//////////////////////////////////////////////////////////
procedure SQLColumnPrivilegesW_orig; external 'odbc32.dll' name 'SQLColumnPrivilegesW';
  procedure SQLColumnPrivilegesW; export; stdcall;
  begin 
   asm 
     jmp SQLColumnPrivilegesW_orig; 
   end; 
  end;
  exports SQLColumnPrivilegesW;
//////////////////////////////////////////////////////////
procedure SQLColumns_orig; external 'odbc32.dll' name 'SQLColumns';
  procedure SQLColumns; export; stdcall;
  begin 
   asm 
     jmp SQLColumns_orig; 
   end; 
  end;
  exports SQLColumns;
//////////////////////////////////////////////////////////
procedure SQLColumnsA_orig; external 'odbc32.dll' name 'SQLColumnsA';
  procedure SQLColumnsA; export; stdcall;
  begin 
   asm 
     jmp SQLColumnsA_orig; 
   end; 
  end;
  exports SQLColumnsA;
//////////////////////////////////////////////////////////
procedure SQLColumnsW_orig; external 'odbc32.dll' name 'SQLColumnsW';
  procedure SQLColumnsW; export; stdcall;
  begin 
   asm 
     jmp SQLColumnsW_orig; 
   end; 
  end;
  exports SQLColumnsW;
//////////////////////////////////////////////////////////
procedure SQLConnect_orig; external 'odbc32.dll' name 'SQLConnect';
  procedure SQLConnect; export; stdcall;
  begin 
   asm 
     jmp SQLConnect_orig; 
   end; 
  end;
  exports SQLConnect;
//////////////////////////////////////////////////////////
procedure SQLConnectA_orig; external 'odbc32.dll' name 'SQLConnectA';
  procedure SQLConnectA; export; stdcall;
  begin 
   asm 
     jmp SQLConnectA_orig; 
   end; 
  end;
  exports SQLConnectA;
//////////////////////////////////////////////////////////
procedure SQLConnectW_orig; external 'odbc32.dll' name 'SQLConnectW';
  procedure SQLConnectW; export; stdcall;
  begin 
   asm 
     jmp SQLConnectW_orig; 
   end; 
  end;
  exports SQLConnectW;
//////////////////////////////////////////////////////////
procedure SQLCopyDesc_orig; external 'odbc32.dll' name 'SQLCopyDesc';
  procedure SQLCopyDesc; export; stdcall;
  begin 
   asm 
     jmp SQLCopyDesc_orig; 
   end; 
  end;
  exports SQLCopyDesc;
//////////////////////////////////////////////////////////
procedure SQLDataSources_orig; external 'odbc32.dll' name 'SQLDataSources';
  procedure SQLDataSources; export; stdcall;
  begin 
   asm 
     jmp SQLDataSources_orig; 
   end; 
  end;
  exports SQLDataSources;
//////////////////////////////////////////////////////////
procedure SQLDataSourcesA_orig; external 'odbc32.dll' name 'SQLDataSourcesA';
  procedure SQLDataSourcesA; export; stdcall;
  begin 
   asm 
     jmp SQLDataSourcesA_orig; 
   end; 
  end;
  exports SQLDataSourcesA;
//////////////////////////////////////////////////////////
procedure SQLDataSourcesW_orig; external 'odbc32.dll' name 'SQLDataSourcesW';
  procedure SQLDataSourcesW; export; stdcall;
  begin 
   asm 
     jmp SQLDataSourcesW_orig; 
   end; 
  end;
  exports SQLDataSourcesW;
//////////////////////////////////////////////////////////
procedure SQLDescribeCol_orig; external 'odbc32.dll' name 'SQLDescribeCol';
  procedure SQLDescribeCol; export; stdcall;
  begin 
   asm 
     jmp SQLDescribeCol_orig; 
   end; 
  end;
  exports SQLDescribeCol;
//////////////////////////////////////////////////////////
procedure SQLDescribeColA_orig; external 'odbc32.dll' name 'SQLDescribeColA';
  procedure SQLDescribeColA; export; stdcall;
  begin 
   asm 
     jmp SQLDescribeColA_orig; 
   end; 
  end;
  exports SQLDescribeColA;
//////////////////////////////////////////////////////////
procedure SQLDescribeColW_orig; external 'odbc32.dll' name 'SQLDescribeColW';
  procedure SQLDescribeColW; export; stdcall;
  begin 
   asm 
     jmp SQLDescribeColW_orig; 
   end; 
  end;
  exports SQLDescribeColW;
//////////////////////////////////////////////////////////
procedure SQLDescribeParam_orig; external 'odbc32.dll' name 'SQLDescribeParam';
  procedure SQLDescribeParam; export; stdcall;
  begin 
   asm 
     jmp SQLDescribeParam_orig; 
   end; 
  end;
  exports SQLDescribeParam;
//////////////////////////////////////////////////////////
procedure SQLDisconnect_orig; external 'odbc32.dll' name 'SQLDisconnect';
  procedure SQLDisconnect; export; stdcall;
  begin 
   asm 
     jmp SQLDisconnect_orig; 
   end; 
  end;
  exports SQLDisconnect;
//////////////////////////////////////////////////////////
procedure SQLDriverConnect_orig; external 'odbc32.dll' name 'SQLDriverConnect';
  procedure SQLDriverConnect; export; stdcall;
  begin 
   asm 
     jmp SQLDriverConnect_orig; 
   end; 
  end;
  exports SQLDriverConnect;
//////////////////////////////////////////////////////////
procedure SQLDriverConnectA_orig; external 'odbc32.dll' name 'SQLDriverConnectA';
  procedure SQLDriverConnectA; export; stdcall;
  begin 
   asm 
     jmp SQLDriverConnectA_orig; 
   end; 
  end;
  exports SQLDriverConnectA;
//////////////////////////////////////////////////////////
procedure SQLDriverConnectW_orig; external 'odbc32.dll' name 'SQLDriverConnectW';
  procedure SQLDriverConnectW; export; stdcall;
  begin 
   asm 
     jmp SQLDriverConnectW_orig; 
   end; 
  end;
  exports SQLDriverConnectW;
//////////////////////////////////////////////////////////
procedure SQLDrivers_orig; external 'odbc32.dll' name 'SQLDrivers';
  procedure SQLDrivers; export; stdcall;
  begin 
   asm 
     jmp SQLDrivers_orig; 
   end; 
  end;
  exports SQLDrivers;
//////////////////////////////////////////////////////////
procedure SQLDriversA_orig; external 'odbc32.dll' name 'SQLDriversA';
  procedure SQLDriversA; export; stdcall;
  begin 
   asm 
     jmp SQLDriversA_orig; 
   end; 
  end;
  exports SQLDriversA;
//////////////////////////////////////////////////////////
procedure SQLDriversW_orig; external 'odbc32.dll' name 'SQLDriversW';
  procedure SQLDriversW; export; stdcall;
  begin 
   asm 
     jmp SQLDriversW_orig; 
   end; 
  end;
  exports SQLDriversW;
//////////////////////////////////////////////////////////
procedure SQLEndTran_orig; external 'odbc32.dll' name 'SQLEndTran';
  procedure SQLEndTran; export; stdcall;
  begin 
   asm 
     jmp SQLEndTran_orig; 
   end; 
  end;
  exports SQLEndTran;
//////////////////////////////////////////////////////////
procedure SQLError_orig; external 'odbc32.dll' name 'SQLError';
  procedure SQLError; export; stdcall;
  begin 
   asm 
     jmp SQLError_orig; 
   end; 
  end;
  exports SQLError;
//////////////////////////////////////////////////////////
procedure SQLErrorA_orig; external 'odbc32.dll' name 'SQLErrorA';
  procedure SQLErrorA; export; stdcall;
  begin 
   asm 
     jmp SQLErrorA_orig; 
   end; 
  end;
  exports SQLErrorA;
//////////////////////////////////////////////////////////
procedure SQLErrorW_orig; external 'odbc32.dll' name 'SQLErrorW';
  procedure SQLErrorW; export; stdcall;
  begin 
   asm 
     jmp SQLErrorW_orig; 
   end; 
  end;
  exports SQLErrorW;
//////////////////////////////////////////////////////////
procedure SQLExecute_orig; external 'odbc32.dll' name 'SQLExecute';
  procedure SQLExecute; export; stdcall;
  begin 
   asm 
     jmp SQLExecute_orig; 
   end; 
  end;
  exports SQLExecute;
//////////////////////////////////////////////////////////
procedure SQLExtendedFetch_orig; external 'odbc32.dll' name 'SQLExtendedFetch';
  procedure SQLExtendedFetch; export; stdcall;
  begin 
   asm 
     jmp SQLExtendedFetch_orig; 
   end; 
  end;
  exports SQLExtendedFetch;
//////////////////////////////////////////////////////////
procedure SQLFetch_orig; external 'odbc32.dll' name 'SQLFetch';
  procedure SQLFetch; export; stdcall;
  begin 
   asm 
     jmp SQLFetch_orig; 
   end; 
  end;
  exports SQLFetch;
//////////////////////////////////////////////////////////
procedure SQLFetchScroll_orig; external 'odbc32.dll' name 'SQLFetchScroll';
  procedure SQLFetchScroll; export; stdcall;
  begin 
   asm 
     jmp SQLFetchScroll_orig; 
   end; 
  end;
  exports SQLFetchScroll;
//////////////////////////////////////////////////////////
procedure SQLForeignKeys_orig; external 'odbc32.dll' name 'SQLForeignKeys';
  procedure SQLForeignKeys; export; stdcall;
  begin 
   asm 
     jmp SQLForeignKeys_orig; 
   end; 
  end;
  exports SQLForeignKeys;
//////////////////////////////////////////////////////////
procedure SQLForeignKeysA_orig; external 'odbc32.dll' name 'SQLForeignKeysA';
  procedure SQLForeignKeysA; export; stdcall;
  begin 
   asm 
     jmp SQLForeignKeysA_orig; 
   end; 
  end;
  exports SQLForeignKeysA;
//////////////////////////////////////////////////////////
procedure SQLForeignKeysW_orig; external 'odbc32.dll' name 'SQLForeignKeysW';
  procedure SQLForeignKeysW; export; stdcall;
  begin 
   asm 
     jmp SQLForeignKeysW_orig; 
   end; 
  end;
  exports SQLForeignKeysW;
//////////////////////////////////////////////////////////
procedure SQLFreeConnect_orig; external 'odbc32.dll' name 'SQLFreeConnect';
  procedure SQLFreeConnect; export; stdcall;
  begin 
   asm 
     jmp SQLFreeConnect_orig; 
   end; 
  end;
  exports SQLFreeConnect;
//////////////////////////////////////////////////////////
procedure SQLFreeEnv_orig; external 'odbc32.dll' name 'SQLFreeEnv';
  procedure SQLFreeEnv; export; stdcall;
  begin 
   asm 
     jmp SQLFreeEnv_orig; 
   end; 
  end;
  exports SQLFreeEnv;
//////////////////////////////////////////////////////////
procedure SQLFreeHandle_orig; external 'odbc32.dll' name 'SQLFreeHandle';
  procedure SQLFreeHandle; export; stdcall;
  begin 
   asm 
     jmp SQLFreeHandle_orig; 
   end; 
  end;
  exports SQLFreeHandle;
//////////////////////////////////////////////////////////
procedure SQLFreeStmt_orig; external 'odbc32.dll' name 'SQLFreeStmt';
  procedure SQLFreeStmt; export; stdcall;
  begin 
   asm 
     jmp SQLFreeStmt_orig; 
   end; 
  end;
  exports SQLFreeStmt;
//////////////////////////////////////////////////////////
procedure SQLGetConnectAttr_orig; external 'odbc32.dll' name 'SQLGetConnectAttr';
  procedure SQLGetConnectAttr; export; stdcall;
  begin 
   asm 
     jmp SQLGetConnectAttr_orig; 
   end; 
  end;
  exports SQLGetConnectAttr;
//////////////////////////////////////////////////////////
procedure SQLGetConnectAttrA_orig; external 'odbc32.dll' name 'SQLGetConnectAttrA';
  procedure SQLGetConnectAttrA; export; stdcall;
  begin 
   asm 
     jmp SQLGetConnectAttrA_orig; 
   end; 
  end;
  exports SQLGetConnectAttrA;
//////////////////////////////////////////////////////////
procedure SQLGetConnectAttrW_orig; external 'odbc32.dll' name 'SQLGetConnectAttrW';
  procedure SQLGetConnectAttrW; export; stdcall;
  begin 
   asm 
     jmp SQLGetConnectAttrW_orig; 
   end; 
  end;
  exports SQLGetConnectAttrW;
//////////////////////////////////////////////////////////
procedure SQLGetConnectOption_orig; external 'odbc32.dll' name 'SQLGetConnectOption';
  procedure SQLGetConnectOption; export; stdcall;
  begin 
   asm 
     jmp SQLGetConnectOption_orig; 
   end; 
  end;
  exports SQLGetConnectOption;
//////////////////////////////////////////////////////////
procedure SQLGetConnectOptionA_orig; external 'odbc32.dll' name 'SQLGetConnectOptionA';
  procedure SQLGetConnectOptionA; export; stdcall;
  begin 
   asm 
     jmp SQLGetConnectOptionA_orig; 
   end; 
  end;
  exports SQLGetConnectOptionA;
//////////////////////////////////////////////////////////
procedure SQLGetConnectOptionW_orig; external 'odbc32.dll' name 'SQLGetConnectOptionW';
  procedure SQLGetConnectOptionW; export; stdcall;
  begin 
   asm 
     jmp SQLGetConnectOptionW_orig; 
   end; 
  end;
  exports SQLGetConnectOptionW;
//////////////////////////////////////////////////////////
procedure SQLGetCursorName_orig; external 'odbc32.dll' name 'SQLGetCursorName';
  procedure SQLGetCursorName; export; stdcall;
  begin 
   asm 
     jmp SQLGetCursorName_orig; 
   end; 
  end;
  exports SQLGetCursorName;
//////////////////////////////////////////////////////////
procedure SQLGetCursorNameA_orig; external 'odbc32.dll' name 'SQLGetCursorNameA';
  procedure SQLGetCursorNameA; export; stdcall;
  begin 
   asm 
     jmp SQLGetCursorNameA_orig; 
   end; 
  end;
  exports SQLGetCursorNameA;
//////////////////////////////////////////////////////////
procedure SQLGetCursorNameW_orig; external 'odbc32.dll' name 'SQLGetCursorNameW';
  procedure SQLGetCursorNameW; export; stdcall;
  begin 
   asm 
     jmp SQLGetCursorNameW_orig; 
   end; 
  end;
  exports SQLGetCursorNameW;
//////////////////////////////////////////////////////////
procedure SQLGetData_orig; external 'odbc32.dll' name 'SQLGetData';
  procedure SQLGetData; export; stdcall;
  begin 
   asm 
     jmp SQLGetData_orig; 
   end; 
  end;
  exports SQLGetData;
//////////////////////////////////////////////////////////
procedure SQLGetDescField_orig; external 'odbc32.dll' name 'SQLGetDescField';
  procedure SQLGetDescField; export; stdcall;
  begin 
   asm 
     jmp SQLGetDescField_orig; 
   end; 
  end;
  exports SQLGetDescField;
//////////////////////////////////////////////////////////
procedure SQLGetDescFieldA_orig; external 'odbc32.dll' name 'SQLGetDescFieldA';
  procedure SQLGetDescFieldA; export; stdcall;
  begin 
   asm 
     jmp SQLGetDescFieldA_orig; 
   end; 
  end;
  exports SQLGetDescFieldA;
//////////////////////////////////////////////////////////
procedure SQLGetDescFieldW_orig; external 'odbc32.dll' name 'SQLGetDescFieldW';
  procedure SQLGetDescFieldW; export; stdcall;
  begin 
   asm 
     jmp SQLGetDescFieldW_orig; 
   end; 
  end;
  exports SQLGetDescFieldW;
//////////////////////////////////////////////////////////
procedure SQLGetDescRec_orig; external 'odbc32.dll' name 'SQLGetDescRec';
  procedure SQLGetDescRec; export; stdcall;
  begin 
   asm 
     jmp SQLGetDescRec_orig; 
   end; 
  end;
  exports SQLGetDescRec;
//////////////////////////////////////////////////////////
procedure SQLGetDescRecA_orig; external 'odbc32.dll' name 'SQLGetDescRecA';
  procedure SQLGetDescRecA; export; stdcall;
  begin 
   asm 
     jmp SQLGetDescRecA_orig; 
   end; 
  end;
  exports SQLGetDescRecA;
//////////////////////////////////////////////////////////
procedure SQLGetDescRecW_orig; external 'odbc32.dll' name 'SQLGetDescRecW';
  procedure SQLGetDescRecW; export; stdcall;
  begin 
   asm 
     jmp SQLGetDescRecW_orig; 
   end; 
  end;
  exports SQLGetDescRecW;
//////////////////////////////////////////////////////////
procedure SQLGetDiagField_orig; external 'odbc32.dll' name 'SQLGetDiagField';
  procedure SQLGetDiagField; export; stdcall;
  begin 
   asm 
     jmp SQLGetDiagField_orig; 
   end; 
  end;
  exports SQLGetDiagField;
//////////////////////////////////////////////////////////
procedure SQLGetDiagFieldA_orig; external 'odbc32.dll' name 'SQLGetDiagFieldA';
  procedure SQLGetDiagFieldA; export; stdcall;
  begin 
   asm 
     jmp SQLGetDiagFieldA_orig; 
   end; 
  end;
  exports SQLGetDiagFieldA;
//////////////////////////////////////////////////////////
procedure SQLGetDiagFieldW_orig; external 'odbc32.dll' name 'SQLGetDiagFieldW';
  procedure SQLGetDiagFieldW; export; stdcall;
  begin 
   asm 
     jmp SQLGetDiagFieldW_orig; 
   end; 
  end;
  exports SQLGetDiagFieldW;
//////////////////////////////////////////////////////////
procedure SQLGetDiagRec_orig; external 'odbc32.dll' name 'SQLGetDiagRec';
  procedure SQLGetDiagRec; export; stdcall;
  begin 
   asm 
     jmp SQLGetDiagRec_orig; 
   end; 
  end;
  exports SQLGetDiagRec;
//////////////////////////////////////////////////////////
procedure SQLGetDiagRecA_orig; external 'odbc32.dll' name 'SQLGetDiagRecA';
  procedure SQLGetDiagRecA; export; stdcall;
  begin 
   asm 
     jmp SQLGetDiagRecA_orig; 
   end; 
  end;
  exports SQLGetDiagRecA;
//////////////////////////////////////////////////////////
procedure SQLGetDiagRecW_orig; external 'odbc32.dll' name 'SQLGetDiagRecW';
  procedure SQLGetDiagRecW; export; stdcall;
  begin 
   asm 
     jmp SQLGetDiagRecW_orig; 
   end; 
  end;
  exports SQLGetDiagRecW;
//////////////////////////////////////////////////////////
procedure SQLGetEnvAttr_orig; external 'odbc32.dll' name 'SQLGetEnvAttr';
  procedure SQLGetEnvAttr; export; stdcall;
  begin 
   asm 
     jmp SQLGetEnvAttr_orig; 
   end; 
  end;
  exports SQLGetEnvAttr;
//////////////////////////////////////////////////////////
procedure SQLGetFunctions_orig; external 'odbc32.dll' name 'SQLGetFunctions';
  procedure SQLGetFunctions; export; stdcall;
  begin 
   asm 
     jmp SQLGetFunctions_orig; 
   end; 
  end;
  exports SQLGetFunctions;
//////////////////////////////////////////////////////////
procedure SQLGetInfo_orig; external 'odbc32.dll' name 'SQLGetInfo';
  procedure SQLGetInfo; export; stdcall;
  begin 
   asm 
     jmp SQLGetInfo_orig; 
   end; 
  end;
  exports SQLGetInfo;
//////////////////////////////////////////////////////////
procedure SQLGetInfoA_orig; external 'odbc32.dll' name 'SQLGetInfoA';
  procedure SQLGetInfoA; export; stdcall;
  begin 
   asm 
     jmp SQLGetInfoA_orig; 
   end; 
  end;
  exports SQLGetInfoA;
//////////////////////////////////////////////////////////
procedure SQLGetInfoW_orig; external 'odbc32.dll' name 'SQLGetInfoW';
  procedure SQLGetInfoW; export; stdcall;
  begin 
   asm 
     jmp SQLGetInfoW_orig; 
   end; 
  end;
  exports SQLGetInfoW;
//////////////////////////////////////////////////////////
procedure SQLGetStmtAttr_orig; external 'odbc32.dll' name 'SQLGetStmtAttr';
  procedure SQLGetStmtAttr; export; stdcall;
  begin 
   asm 
     jmp SQLGetStmtAttr_orig; 
   end; 
  end;
  exports SQLGetStmtAttr;
//////////////////////////////////////////////////////////
procedure SQLGetStmtAttrA_orig; external 'odbc32.dll' name 'SQLGetStmtAttrA';
  procedure SQLGetStmtAttrA; export; stdcall;
  begin 
   asm 
     jmp SQLGetStmtAttrA_orig; 
   end; 
  end;
  exports SQLGetStmtAttrA;
//////////////////////////////////////////////////////////
procedure SQLGetStmtAttrW_orig; external 'odbc32.dll' name 'SQLGetStmtAttrW';
  procedure SQLGetStmtAttrW; export; stdcall;
  begin 
   asm 
     jmp SQLGetStmtAttrW_orig; 
   end; 
  end;
  exports SQLGetStmtAttrW;
//////////////////////////////////////////////////////////
procedure SQLGetStmtOption_orig; external 'odbc32.dll' name 'SQLGetStmtOption';
  procedure SQLGetStmtOption; export; stdcall;
  begin 
   asm 
     jmp SQLGetStmtOption_orig; 
   end; 
  end;
  exports SQLGetStmtOption;
//////////////////////////////////////////////////////////
procedure SQLGetTypeInfo_orig; external 'odbc32.dll' name 'SQLGetTypeInfo';
  procedure SQLGetTypeInfo; export; stdcall;
  begin 
   asm 
     jmp SQLGetTypeInfo_orig; 
   end; 
  end;
  exports SQLGetTypeInfo;
//////////////////////////////////////////////////////////
procedure SQLGetTypeInfoA_orig; external 'odbc32.dll' name 'SQLGetTypeInfoA';
  procedure SQLGetTypeInfoA; export; stdcall;
  begin 
   asm 
     jmp SQLGetTypeInfoA_orig; 
   end; 
  end;
  exports SQLGetTypeInfoA;
//////////////////////////////////////////////////////////
procedure SQLGetTypeInfoW_orig; external 'odbc32.dll' name 'SQLGetTypeInfoW';
  procedure SQLGetTypeInfoW; export; stdcall;
  begin 
   asm 
     jmp SQLGetTypeInfoW_orig; 
   end; 
  end;
  exports SQLGetTypeInfoW;
//////////////////////////////////////////////////////////
procedure SQLMoreResults_orig; external 'odbc32.dll' name 'SQLMoreResults';
  procedure SQLMoreResults; export; stdcall;
  begin 
   asm 
     jmp SQLMoreResults_orig; 
   end; 
  end;
  exports SQLMoreResults;
//////////////////////////////////////////////////////////
procedure SQLNativeSql_orig; external 'odbc32.dll' name 'SQLNativeSql';
  procedure SQLNativeSql; export; stdcall;
  begin 
   asm 
     jmp SQLNativeSql_orig; 
   end; 
  end;
  exports SQLNativeSql;
//////////////////////////////////////////////////////////
procedure SQLNativeSqlA_orig; external 'odbc32.dll' name 'SQLNativeSqlA';
  procedure SQLNativeSqlA; export; stdcall;
  begin 
   asm 
     jmp SQLNativeSqlA_orig; 
   end; 
  end;
  exports SQLNativeSqlA;
//////////////////////////////////////////////////////////
procedure SQLNativeSqlW_orig; external 'odbc32.dll' name 'SQLNativeSqlW';
  procedure SQLNativeSqlW; export; stdcall;
  begin 
   asm 
     jmp SQLNativeSqlW_orig; 
   end; 
  end;
  exports SQLNativeSqlW;
//////////////////////////////////////////////////////////
procedure SQLNumParams_orig; external 'odbc32.dll' name 'SQLNumParams';
  procedure SQLNumParams; export; stdcall;
  begin 
   asm 
     jmp SQLNumParams_orig; 
   end; 
  end;
  exports SQLNumParams;
//////////////////////////////////////////////////////////
procedure SQLNumResultCols_orig; external 'odbc32.dll' name 'SQLNumResultCols';
  procedure SQLNumResultCols; export; stdcall;
  begin 
   asm 
     jmp SQLNumResultCols_orig; 
   end; 
  end;
  exports SQLNumResultCols;
//////////////////////////////////////////////////////////
procedure SQLParamData_orig; external 'odbc32.dll' name 'SQLParamData';
  procedure SQLParamData; export; stdcall;
  begin 
   asm 
     jmp SQLParamData_orig; 
   end; 
  end;
  exports SQLParamData;
//////////////////////////////////////////////////////////
procedure SQLParamOptions_orig; external 'odbc32.dll' name 'SQLParamOptions';
  procedure SQLParamOptions; export; stdcall;
  begin 
   asm 
     jmp SQLParamOptions_orig; 
   end; 
  end;
  exports SQLParamOptions;
//////////////////////////////////////////////////////////
procedure SQLPrepare_orig; external 'odbc32.dll' name 'SQLPrepare';
  procedure SQLPrepare; export; stdcall;
  begin 
   asm 
     jmp SQLPrepare_orig; 
   end; 
  end;
  exports SQLPrepare;
//////////////////////////////////////////////////////////
procedure SQLPrepareA_orig; external 'odbc32.dll' name 'SQLPrepareA';
  procedure SQLPrepareA; export; stdcall;
  begin 
   asm 
     jmp SQLPrepareA_orig; 
   end; 
  end;
  exports SQLPrepareA;
//////////////////////////////////////////////////////////
procedure SQLPrepareW_orig; external 'odbc32.dll' name 'SQLPrepareW';
  procedure SQLPrepareW; export; stdcall;
  begin 
   asm 
     jmp SQLPrepareW_orig; 
   end; 
  end;
  exports SQLPrepareW;
//////////////////////////////////////////////////////////
procedure SQLPrimaryKeys_orig; external 'odbc32.dll' name 'SQLPrimaryKeys';
  procedure SQLPrimaryKeys; export; stdcall;
  begin 
   asm 
     jmp SQLPrimaryKeys_orig; 
   end; 
  end;
  exports SQLPrimaryKeys;
//////////////////////////////////////////////////////////
procedure SQLPrimaryKeysA_orig; external 'odbc32.dll' name 'SQLPrimaryKeysA';
  procedure SQLPrimaryKeysA; export; stdcall;
  begin 
   asm 
     jmp SQLPrimaryKeysA_orig; 
   end; 
  end;
  exports SQLPrimaryKeysA;
//////////////////////////////////////////////////////////
procedure SQLPrimaryKeysW_orig; external 'odbc32.dll' name 'SQLPrimaryKeysW';
  procedure SQLPrimaryKeysW; export; stdcall;
  begin 
   asm 
     jmp SQLPrimaryKeysW_orig; 
   end; 
  end;
  exports SQLPrimaryKeysW;
//////////////////////////////////////////////////////////
procedure SQLProcedureColumns_orig; external 'odbc32.dll' name 'SQLProcedureColumns';
  procedure SQLProcedureColumns; export; stdcall;
  begin 
   asm 
     jmp SQLProcedureColumns_orig; 
   end; 
  end;
  exports SQLProcedureColumns;
//////////////////////////////////////////////////////////
procedure SQLProcedureColumnsA_orig; external 'odbc32.dll' name 'SQLProcedureColumnsA';
  procedure SQLProcedureColumnsA; export; stdcall;
  begin 
   asm 
     jmp SQLProcedureColumnsA_orig; 
   end; 
  end;
  exports SQLProcedureColumnsA;
//////////////////////////////////////////////////////////
procedure SQLProcedureColumnsW_orig; external 'odbc32.dll' name 'SQLProcedureColumnsW';
  procedure SQLProcedureColumnsW; export; stdcall;
  begin 
   asm 
     jmp SQLProcedureColumnsW_orig; 
   end; 
  end;
  exports SQLProcedureColumnsW;
//////////////////////////////////////////////////////////
procedure SQLProcedures_orig; external 'odbc32.dll' name 'SQLProcedures';
  procedure SQLProcedures; export; stdcall;
  begin 
   asm 
     jmp SQLProcedures_orig; 
   end; 
  end;
  exports SQLProcedures;
//////////////////////////////////////////////////////////
procedure SQLProceduresA_orig; external 'odbc32.dll' name 'SQLProceduresA';
  procedure SQLProceduresA; export; stdcall;
  begin 
   asm 
     jmp SQLProceduresA_orig; 
   end; 
  end;
  exports SQLProceduresA;
//////////////////////////////////////////////////////////
procedure SQLProceduresW_orig; external 'odbc32.dll' name 'SQLProceduresW';
  procedure SQLProceduresW; export; stdcall;
  begin 
   asm 
     jmp SQLProceduresW_orig; 
   end; 
  end;
  exports SQLProceduresW;
//////////////////////////////////////////////////////////
procedure SQLPutData_orig; external 'odbc32.dll' name 'SQLPutData';
  procedure SQLPutData; export; stdcall;
  begin 
   asm 
     jmp SQLPutData_orig; 
   end; 
  end;
  exports SQLPutData;
//////////////////////////////////////////////////////////
procedure SQLRowCount_orig; external 'odbc32.dll' name 'SQLRowCount';
  procedure SQLRowCount; export; stdcall;
  begin 
   asm 
     jmp SQLRowCount_orig; 
   end; 
  end;
  exports SQLRowCount;
//////////////////////////////////////////////////////////
procedure SQLSetConnectAttr_orig; external 'odbc32.dll' name 'SQLSetConnectAttr';
  procedure SQLSetConnectAttr; export; stdcall;
  begin 
   asm 
     jmp SQLSetConnectAttr_orig; 
   end; 
  end;
  exports SQLSetConnectAttr;
//////////////////////////////////////////////////////////
procedure SQLSetConnectAttrA_orig; external 'odbc32.dll' name 'SQLSetConnectAttrA';
  procedure SQLSetConnectAttrA; export; stdcall;
  begin 
   asm 
     jmp SQLSetConnectAttrA_orig; 
   end; 
  end;
  exports SQLSetConnectAttrA;
//////////////////////////////////////////////////////////
procedure SQLSetConnectAttrW_orig; external 'odbc32.dll' name 'SQLSetConnectAttrW';
  procedure SQLSetConnectAttrW; export; stdcall;
  begin 
   asm 
     jmp SQLSetConnectAttrW_orig; 
   end; 
  end;
  exports SQLSetConnectAttrW;
//////////////////////////////////////////////////////////
procedure SQLSetConnectOption_orig; external 'odbc32.dll' name 'SQLSetConnectOption';
  procedure SQLSetConnectOption; export; stdcall;
  begin 
   asm 
     jmp SQLSetConnectOption_orig; 
   end; 
  end;
  exports SQLSetConnectOption;
//////////////////////////////////////////////////////////
procedure SQLSetConnectOptionA_orig; external 'odbc32.dll' name 'SQLSetConnectOptionA';
  procedure SQLSetConnectOptionA; export; stdcall;
  begin 
   asm 
     jmp SQLSetConnectOptionA_orig; 
   end; 
  end;
  exports SQLSetConnectOptionA;
//////////////////////////////////////////////////////////
procedure SQLSetConnectOptionW_orig; external 'odbc32.dll' name 'SQLSetConnectOptionW';
  procedure SQLSetConnectOptionW; export; stdcall;
  begin 
   asm 
     jmp SQLSetConnectOptionW_orig; 
   end; 
  end;
  exports SQLSetConnectOptionW;
//////////////////////////////////////////////////////////
procedure SQLSetCursorName_orig; external 'odbc32.dll' name 'SQLSetCursorName';
  procedure SQLSetCursorName; export; stdcall;
  begin 
   asm 
     jmp SQLSetCursorName_orig; 
   end; 
  end;
  exports SQLSetCursorName;
//////////////////////////////////////////////////////////
procedure SQLSetCursorNameA_orig; external 'odbc32.dll' name 'SQLSetCursorNameA';
  procedure SQLSetCursorNameA; export; stdcall;
  begin 
   asm 
     jmp SQLSetCursorNameA_orig; 
   end; 
  end;
  exports SQLSetCursorNameA;
//////////////////////////////////////////////////////////
procedure SQLSetCursorNameW_orig; external 'odbc32.dll' name 'SQLSetCursorNameW';
  procedure SQLSetCursorNameW; export; stdcall;
  begin 
   asm 
     jmp SQLSetCursorNameW_orig; 
   end; 
  end;
  exports SQLSetCursorNameW;
//////////////////////////////////////////////////////////
procedure SQLSetDescField_orig; external 'odbc32.dll' name 'SQLSetDescField';
  procedure SQLSetDescField; export; stdcall;
  begin 
   asm 
     jmp SQLSetDescField_orig; 
   end; 
  end;
  exports SQLSetDescField;
//////////////////////////////////////////////////////////
procedure SQLSetDescFieldA_orig; external 'odbc32.dll' name 'SQLSetDescFieldA';
  procedure SQLSetDescFieldA; export; stdcall;
  begin 
   asm 
     jmp SQLSetDescFieldA_orig; 
   end; 
  end;
  exports SQLSetDescFieldA;
//////////////////////////////////////////////////////////
procedure SQLSetDescFieldW_orig; external 'odbc32.dll' name 'SQLSetDescFieldW';
  procedure SQLSetDescFieldW; export; stdcall;
  begin 
   asm 
     jmp SQLSetDescFieldW_orig; 
   end; 
  end;
  exports SQLSetDescFieldW;
//////////////////////////////////////////////////////////
procedure SQLSetDescRec_orig; external 'odbc32.dll' name 'SQLSetDescRec';
  procedure SQLSetDescRec; export; stdcall;
  begin 
   asm 
     jmp SQLSetDescRec_orig; 
   end; 
  end;
  exports SQLSetDescRec;
//////////////////////////////////////////////////////////
procedure SQLSetEnvAttr_orig; external 'odbc32.dll' name 'SQLSetEnvAttr';
  procedure SQLSetEnvAttr; export; stdcall;
  begin 
   asm 
     jmp SQLSetEnvAttr_orig; 
   end; 
  end;
  exports SQLSetEnvAttr;
//////////////////////////////////////////////////////////
procedure SQLSetParam_orig; external 'odbc32.dll' name 'SQLSetParam';
  procedure SQLSetParam; export; stdcall;
  begin 
   asm 
     jmp SQLSetParam_orig; 
   end; 
  end;
  exports SQLSetParam;
//////////////////////////////////////////////////////////
procedure SQLSetPos_orig; external 'odbc32.dll' name 'SQLSetPos';
  procedure SQLSetPos; export; stdcall;
  begin 
   asm 
     jmp SQLSetPos_orig; 
   end; 
  end;
  exports SQLSetPos;
//////////////////////////////////////////////////////////
procedure SQLSetScrollOptions_orig; external 'odbc32.dll' name 'SQLSetScrollOptions';
  procedure SQLSetScrollOptions; export; stdcall;
  begin 
   asm 
     jmp SQLSetScrollOptions_orig; 
   end; 
  end;
  exports SQLSetScrollOptions;
//////////////////////////////////////////////////////////
procedure SQLSetStmtAttr_orig; external 'odbc32.dll' name 'SQLSetStmtAttr';
  procedure SQLSetStmtAttr; export; stdcall;
  begin 
   asm 
     jmp SQLSetStmtAttr_orig; 
   end; 
  end;
  exports SQLSetStmtAttr;
//////////////////////////////////////////////////////////
procedure SQLSetStmtAttrA_orig; external 'odbc32.dll' name 'SQLSetStmtAttrA';
  procedure SQLSetStmtAttrA; export; stdcall;
  begin 
   asm 
     jmp SQLSetStmtAttrA_orig; 
   end; 
  end;
  exports SQLSetStmtAttrA;
//////////////////////////////////////////////////////////
procedure SQLSetStmtAttrW_orig; external 'odbc32.dll' name 'SQLSetStmtAttrW';
  procedure SQLSetStmtAttrW; export; stdcall;
  begin 
   asm 
     jmp SQLSetStmtAttrW_orig; 
   end; 
  end;
  exports SQLSetStmtAttrW;
//////////////////////////////////////////////////////////
procedure SQLSetStmtOption_orig; external 'odbc32.dll' name 'SQLSetStmtOption';
  procedure SQLSetStmtOption; export; stdcall;
  begin 
   asm 
     jmp SQLSetStmtOption_orig; 
   end; 
  end;
  exports SQLSetStmtOption;
//////////////////////////////////////////////////////////
procedure SQLSpecialColumns_orig; external 'odbc32.dll' name 'SQLSpecialColumns';
  procedure SQLSpecialColumns; export; stdcall;
  begin 
   asm 
     jmp SQLSpecialColumns_orig; 
   end; 
  end;
  exports SQLSpecialColumns;
//////////////////////////////////////////////////////////
procedure SQLSpecialColumnsA_orig; external 'odbc32.dll' name 'SQLSpecialColumnsA';
  procedure SQLSpecialColumnsA; export; stdcall;
  begin 
   asm 
     jmp SQLSpecialColumnsA_orig; 
   end; 
  end;
  exports SQLSpecialColumnsA;
//////////////////////////////////////////////////////////
procedure SQLSpecialColumnsW_orig; external 'odbc32.dll' name 'SQLSpecialColumnsW';
  procedure SQLSpecialColumnsW; export; stdcall;
  begin 
   asm 
     jmp SQLSpecialColumnsW_orig; 
   end; 
  end;
  exports SQLSpecialColumnsW;
//////////////////////////////////////////////////////////
procedure SQLStatistics_orig; external 'odbc32.dll' name 'SQLStatistics';
  procedure SQLStatistics; export; stdcall;
  begin 
   asm 
     jmp SQLStatistics_orig; 
   end; 
  end;
  exports SQLStatistics;
//////////////////////////////////////////////////////////
procedure SQLStatisticsA_orig; external 'odbc32.dll' name 'SQLStatisticsA';
  procedure SQLStatisticsA; export; stdcall;
  begin 
   asm 
     jmp SQLStatisticsA_orig; 
   end; 
  end;
  exports SQLStatisticsA;
//////////////////////////////////////////////////////////
procedure SQLStatisticsW_orig; external 'odbc32.dll' name 'SQLStatisticsW';
  procedure SQLStatisticsW; export; stdcall;
  begin 
   asm 
     jmp SQLStatisticsW_orig; 
   end; 
  end;
  exports SQLStatisticsW;
//////////////////////////////////////////////////////////
procedure SQLTablePrivileges_orig; external 'odbc32.dll' name 'SQLTablePrivileges';
  procedure SQLTablePrivileges; export; stdcall;
  begin 
   asm 
     jmp SQLTablePrivileges_orig; 
   end; 
  end;
  exports SQLTablePrivileges;
//////////////////////////////////////////////////////////
procedure SQLTablePrivilegesA_orig; external 'odbc32.dll' name 'SQLTablePrivilegesA';
  procedure SQLTablePrivilegesA; export; stdcall;
  begin 
   asm 
     jmp SQLTablePrivilegesA_orig; 
   end; 
  end;
  exports SQLTablePrivilegesA;
//////////////////////////////////////////////////////////
procedure SQLTablePrivilegesW_orig; external 'odbc32.dll' name 'SQLTablePrivilegesW';
  procedure SQLTablePrivilegesW; export; stdcall;
  begin 
   asm 
     jmp SQLTablePrivilegesW_orig; 
   end; 
  end;
  exports SQLTablePrivilegesW;
//////////////////////////////////////////////////////////
procedure SQLTables_orig; external 'odbc32.dll' name 'SQLTables';
  procedure SQLTables; export; stdcall;
  begin 
   asm 
     jmp SQLTables_orig; 
   end; 
  end;
  exports SQLTables;
//////////////////////////////////////////////////////////
procedure SQLTablesA_orig; external 'odbc32.dll' name 'SQLTablesA';
  procedure SQLTablesA; export; stdcall;
  begin 
   asm 
     jmp SQLTablesA_orig; 
   end; 
  end;
  exports SQLTablesA;
//////////////////////////////////////////////////////////
procedure SQLTablesW_orig; external 'odbc32.dll' name 'SQLTablesW';
  procedure SQLTablesW; export; stdcall;
  begin 
   asm 
     jmp SQLTablesW_orig; 
   end; 
  end;
  exports SQLTablesW;
//////////////////////////////////////////////////////////
procedure SQLTransact_orig; external 'odbc32.dll' name 'SQLTransact';
  procedure SQLTransact; export; stdcall;
  begin 
   asm 
     jmp SQLTransact_orig; 
   end; 
  end;
  exports SQLTransact;
//////////////////////////////////////////////////////////
procedure SearchStatusCode_orig; external 'odbc32.dll' name 'SearchStatusCode';
  procedure SearchStatusCode; export; stdcall;
  begin 
   asm 
     jmp SearchStatusCode_orig; 
   end; 
  end;
  exports SearchStatusCode;
//////////////////////////////////////////////////////////
procedure VFreeErrors_orig; external 'odbc32.dll' name 'VFreeErrors';
  procedure VFreeErrors; export; stdcall;
  begin 
   asm 
     jmp VFreeErrors_orig; 
   end; 
  end;
  exports VFreeErrors;
//////////////////////////////////////////////////////////
procedure VRetrieveDriverErrorsRowCol_orig; external 'odbc32.dll' name 'VRetrieveDriverErrorsRowCol';
  procedure VRetrieveDriverErrorsRowCol; export; stdcall;
  begin 
   asm 
     jmp VRetrieveDriverErrorsRowCol_orig; 
   end; 
  end;
  exports VRetrieveDriverErrorsRowCol;
//////////////////////////////////////////////////////////
procedure ValidateErrorQueue_orig; external 'odbc32.dll' name 'ValidateErrorQueue';
  procedure ValidateErrorQueue; export; stdcall;
  begin 
   asm 
     jmp ValidateErrorQueue_orig; 
   end; 
  end;
  exports ValidateErrorQueue;
//////////////////////////////////////////////////////////
procedure g_hHeapMalloc_orig; external 'odbc32.dll' name 'g_hHeapMalloc';
  procedure g_hHeapMalloc; export; stdcall;
  begin 
   asm 
     jmp g_hHeapMalloc_orig; 
   end; 
  end;
  exports g_hHeapMalloc;

begin
  g_ms:=1024;
  g_LastErrorTime:=0;
  g_cnt:=c_start;
  GetIniFile();
  InitializeCriticalSection(lpCriticalSection);
end.
